diff --git a/web/regression/feature_utils/pgadmin_page.py b/web/regression/feature_utils/pgadmin_page.py
index 33cc8fc4c..b5b8fb5d7 100644
--- a/web/regression/feature_utils/pgadmin_page.py
+++ b/web/regression/feature_utils/pgadmin_page.py
@@ -8,6 +8,7 @@
 ##########################################################################
 
 import time
+import sys
 
 from selenium import webdriver
 from selenium.common.exceptions import NoSuchElementException, \
@@ -18,6 +19,9 @@ from selenium.webdriver.common.keys import Keys
 from selenium.webdriver.support import expected_conditions as EC
 from selenium.webdriver.support.ui import WebDriverWait
 from selenium.webdriver.common.by import By
+from regression.feature_utils.locators import QueryToolLocators, \
+    NavMenuLocators
+from regression.feature_utils.tree_area_locators import TreeAreaLocators
 
 
 class PgadminPage:
@@ -84,8 +88,10 @@ class PgadminPage:
         self.find_by_css_selector("button[type='save'].btn.btn-primary").\
             click()
 
-        self.find_by_xpath(
-            "//*[@id='tree']//*[.='" + server_config['name'] + "']")
+        WebDriverWait(self.driver, 10).until(
+            EC.visibility_of_element_located(
+                (By.XPATH,
+                 "//*[@id='tree']//*[.='" + server_config['name'] + "']")))
 
     def open_query_tool(self):
         self.driver.find_element_by_link_text("Tools").click()
@@ -151,6 +157,24 @@ class PgadminPage:
                 'contains(.,"Don\'t save")]'))
         self.driver.switch_to.default_content()
 
+    def clear_query_tool(self):
+        self.click_element(
+            self.find_by_css_selector(QueryToolLocators.btn_clear_dropdown)
+        )
+        ActionChains(self.driver).move_to_element(
+            self.find_by_css_selector(QueryToolLocators.btn_clear)).perform()
+        self.click_element(
+            self.find_by_css_selector(QueryToolLocators.btn_clear)
+        )
+        self.click_modal('Yes')
+
+    def execute_query(self, query):
+        self.fill_codemirror_area_with(query)
+        execute_button = self.find_by_css_selector(
+            QueryToolLocators.btn_execute_query_css)
+        execute_button.click()
+        self.wait_for_query_tool_loading_indicator_to_disappear()
+
     def close_data_grid(self):
         self.driver.switch_to_default_content()
         xpath = "//*[@id='dockerContainer']/div/div[3]/div/div[2]/div[1]"
@@ -188,14 +212,40 @@ class PgadminPage:
                 if attempts == 0:
                     raise Exception(e)
 
+    def get_expansion_status_of_node(self, xpath_node):
+        """get the expansion status for a node through xpath"""
+        node_is_expanded = False
+        element = self.find_by_xpath(xpath_node)
+        if element.get_attribute("aria-expanded") == 'true':
+            node_is_expanded = True
+        return node_is_expanded
+
     def toggle_open_servers_group(self):
         """This will open Servers group to display underlying nodes"""
+        is_expanded = False
         self.wait_for_spinner_to_disappear()
-        server_group = self.find_by_xpath(
-            "//div[@id='tree']//span[@class='aciTreeItem']"
-            "/span[(@class='aciTreeText') and starts-with(text(),'Servers ') "
-            "or starts-with(text(), 'Servers')]")
-        ActionChains(self.driver).double_click(server_group).perform()
+        if self.check_if_element_exist_by_xpath(
+                TreeAreaLocators.server_group_node):
+            if self.get_expansion_status_of_node(
+                    TreeAreaLocators.server_group_node_exp_status):
+                is_expanded = True
+            else:
+                webdriver.ActionChains(self.driver).double_click(
+                    self.find_by_xpath(
+                        TreeAreaLocators.
+                        server_group_node)).perform()
+                if self.check_if_element_exist_by_xpath(
+                        TreeAreaLocators.server_group_sub_nodes):
+                    is_expanded = True
+                else:
+                    print(
+                        "(toggle_open_servers_group)The Server Group "
+                        "node is clicked to expand but it is not expanded",
+                        file=sys.stderr)
+        else:
+            print("The Server Group node is not visible",
+                  file=sys.stderr)
+        return is_expanded
 
     def toggle_open_tree_item(self, tree_item_text):
         # 'sleep' here helps in cases where underlying nodes are auto opened.
@@ -203,8 +253,7 @@ class PgadminPage:
         # even if the underlying node to be clicked was Opened.
         time.sleep(.6)
         item_with_text = self.find_by_xpath(
-            "//div[@id='tree']//span[@class='aciTreeItem']/span["
-            "(@class='aciTreeText') and text()='" + tree_item_text + "']")
+            TreeAreaLocators.specified_tree_node.format(tree_item_text))
 
         self.driver.execute_script("arguments[0].scrollIntoView()",
                                    item_with_text)
@@ -215,6 +264,17 @@ class PgadminPage:
             item = item_with_text.find_element_by_xpath(
                 ".//parent::*[@class='aciTreeItem']")
             ActionChains(self.driver).double_click(item).perform()
+        retry = 3
+        while retry > 0:
+            try:
+                WebDriverWait(self.driver, 5).until((lambda item_with_text: (
+                    item_with_text.find_element_by_xpath(
+                        ".//ancestor::*[@class='aciTreeLine']").
+                    get_attribute("aria-expanded") == 'true')))
+                break
+            except TimeoutException:
+                retry -= 1
+                pass
 
     def toggle_open_tables_node(self):
         """The function will be used for opening Tables node only"""
@@ -454,15 +514,14 @@ class PgadminPage:
 
     def click_tab(self, tab_name):
         WebDriverWait(self.driver, 10).until(EC.element_to_be_clickable(
-            (By.XPATH, "//*[contains(@class,'wcTabTop')]//"
-                       "*[contains(@class,'wcPanelTab') "
-                       "and contains(.,'" + tab_name + "')]")))
-
-        tab = self.find_by_xpath("//*[contains(@class,'wcTabTop')]//"
-                                 "*[contains(@class,'wcPanelTab') "
-                                 "and contains(.,'" + tab_name + "')]")
-
-        self.click_element(tab)
+            (By.XPATH, NavMenuLocators.select_tab_xpath.format(tab_name))))
+        click_tab = True
+        while click_tab:
+            tab = self.find_by_xpath(
+                NavMenuLocators.select_tab_xpath.format(tab_name))
+            self.click_element(tab)
+            if 'wcPanelTabActive' in tab.get_attribute('class'):
+                break
 
     def wait_for_input_by_element(self, element, content):
         def input_field_has_content(driver):
@@ -539,7 +598,7 @@ class PgadminPage:
             except NoSuchElementException:
                 return True
 
-        self._wait_for("spinner to disappear", spinner_has_disappeared)
+        self._wait_for("spinner to disappear", spinner_has_disappeared, 20)
 
     def wait_for_query_tool_loading_indicator_to_disappear(self):
         def spinner_has_disappeared(driver):
@@ -553,7 +612,12 @@ class PgadminPage:
                 time.sleep(0.5)
                 return True
 
-        self._wait_for("spinner to disappear", spinner_has_disappeared)
+        self._wait_for("spinner to disappear", spinner_has_disappeared, 20)
+
+    def wait_for_query_tool_loading_indicator_to_appear(self):
+        self.check_if_element_exist_by_xpath(
+            "//div[@id='editor-panel']//"
+            "div[@class='pg-sp-container sql-editor-busy-fetching']")
 
     def wait_for_app(self):
         def page_shows_app(driver):
@@ -574,10 +638,98 @@ class PgadminPage:
         return element_selector(self.driver)
 
     def _wait_for(self, waiting_for_message, condition_met_function,
-                  timeout=3):
+                  timeout=5):
         if timeout is None:
             timeout = self.timeout
         return WebDriverWait(self.driver, timeout, 0.01).until(
             condition_met_function,
             "Timed out waiting for " + waiting_for_message
         )
+
+    def wait_for_elements(self, find_method_with_args):
+        """Using xpath, it will wait for elements"""
+        def element_if_it_exists(driver):
+            try:
+                element = find_method_with_args(driver)
+                if len(element) > 0 and element[0].is_displayed() and element[
+                        0].is_enabled():
+                    return element
+            except NoSuchElementException:
+                return False
+
+        return self._wait_for("element to exist", element_if_it_exists)
+
+    def find_by_xpath_list(self, xpath):
+        """This will find out list of elements through a single xpath"""
+        return self.wait_for_elements(
+            lambda driver: driver.find_elements_by_xpath(xpath))
+
+    def get_index_of_element(self, element_list, target_string):
+        """it will return index of an element from provided element list"""
+        index_of_required_server = -1
+        if len(element_list) > 0:
+            for index, element in enumerate(element_list):
+                if element.text.startswith(target_string) and (
+                        target_string in element.text):
+                    index_of_required_server = index
+                    break
+        else:
+            print("There seems no record in the provided element list")
+        return index_of_required_server
+
+    def set_switch_box_status(self, switch_box, required_status):
+        """it will change switch box status to required one. Two elements
+        of the switch boxes are to be provided i) button which is needed to
+         toggle ii) Yes for True or No for False"""
+        status_changed_successfully = False
+        switch_box_element = self.find_by_xpath(switch_box)
+
+        if required_status == 'Yes':
+            if 'off' in switch_box_element.get_attribute("class"):
+                switch_box_element.click()
+                time.sleep(1)
+                if 'success' in switch_box_element.get_attribute("class"):
+                    status_changed_successfully = True
+                else:
+                    print(
+                        "(set_switch_box_status)Clicked the "
+                        "element to change its status but "
+                        "it did not changed",
+                        file=sys.stderr)
+            elif 'success' in switch_box_element.get_attribute("class"):
+                status_changed_successfully = True
+        else:
+            if 'success' in switch_box_element.get_attribute("class"):
+                switch_box_element.click()
+                if 'off' in switch_box_element.get_attribute("class"):
+                    status_changed_successfully = True
+                else:
+                    print(
+                        "(set_switch_box_status)Clicked the element to "
+                        "change its status but it did not changed",
+                        file=sys.stderr)
+            elif 'off' in switch_box_element.get_attribute("class"):
+                status_changed_successfully = True
+        return status_changed_successfully
+
+    def retry_click_operation(self, element_to_click,
+                              element_to_verify_after_click):
+        """This will attempt to click add button multiple time,
+        some different exception encountered while clicking, so handled
+        through this"""
+
+        click_status = False
+        attempt = 0
+
+        while click_status is not True and attempt < 5:
+            try:
+                if element_to_verify_after_click.is_displayed():
+                    click_status = True
+                element_to_click.click()
+                if element_to_verify_after_click.is_displayed():
+                    click_status = True
+            except Exception:
+                print("The click operation is not performed for "
+                      "attempt %s, will try 5 attempts" % attempt)
+            attempt = +1
+        return click_status
diff --git a/web/regression/feature_utils/tree_area_locators.py b/web/regression/feature_utils/tree_area_locators.py
new file mode 100644
index 000000000..524058f09
--- /dev/null
+++ b/web/regression/feature_utils/tree_area_locators.py
@@ -0,0 +1,31 @@
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2019, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+
+class TreeAreaLocators():
+    """This will contains element locators for tree area, will also contain
+    parametrized xpath where applicable"""
+
+    server_group_node = \
+        "//div[@id='tree']//span[@class='aciTreeItem']" \
+        "/span[(@class='aciTreeText') and starts-with(text(),'Servers ') or " \
+        "starts-with(text(), 'Servers')]"
+
+    server_group_node_exp_status = "//div[div[span[span[" \
+                                   "(@class='aciTreeText') and " \
+                                   "(text()='Servers ' or " \
+                                   "text()='Servers')]]]]"
+
+    server_group_sub_nodes = \
+        "//div[div[span[span[contains(text(),'Servers')]]]]/" \
+        "following-sibling::ul/li/div/div/div/span[2]/" \
+        "span[@class='aciTreeText']"
+
+    specified_tree_node = \
+        "//div[@id='tree']//span[@class='aciTreeItem']/" \
+        "span[(@class='aciTreeText') and text()='{}']"
diff --git a/web/regression/python_test_utils/test_gui_helper.py b/web/regression/python_test_utils/test_gui_helper.py
index 5174492e2..c31787cc7 100644
--- a/web/regression/python_test_utils/test_gui_helper.py
+++ b/web/regression/python_test_utils/test_gui_helper.py
@@ -12,42 +12,32 @@ def close_bgprocess_popup(tester):
     """
     Allows us to close the background process popup window
     """
-    screen_shot_taken = False
     # In cases where backup div is not closed (sometime due to some error)
     try:
-        if tester.driver.find_element_by_css_selector(
-                ".ajs-message.ajs-bg-bgprocess.ajs-visible"):
-            tester._screenshot()
-            screen_shot_taken = True
-            tester.driver.find_element_by_css_selector(
-                ".btn.btn-sm-sq.btn-primary.pg-bg-close > i").click()
+        tester.page.wait_for_element_to_disappear(
+            lambda x: tester.driver.find_element_by_xpath(
+                ".ajs-message.ajs-bg-bgprocess.ajs-visible"))
     except Exception:
-        pass
+        tester.driver.find_element_by_css_selector(
+            ".btn.btn-sm-sq.btn-primary.pg-bg-close > i").click()
 
     # In cases where restore div is not closed (sometime due to some error)
     try:
-        if tester.driver.find_element_by_xpath(
+        tester.page.wait_for_element_to_disappear(
+            lambda x: tester.driver.find_element_by_xpath(
                 "//div[@class='card-header bg-primary d-flex']/div"
-                "[contains(text(), 'Restoring backup')]"):
-            tester._screenshot()
-            screen_shot_taken = True
-            tester.driver.find_element_by_css_selector(
-                ".btn.btn-sm-sq.btn-primary.pg-bg-close > i").click()
+                "[contains(text(), 'Restoring backup')]"))
     except Exception:
-        pass
+        tester.driver.find_element_by_css_selector(
+            ".btn.btn-sm-sq.btn-primary.pg-bg-close > i").click()
 
     # In cases where maintenance window is not closed (sometime due to some
     # error)
     try:
-        if tester.driver.find_element_by_xpath(
+        tester.page.wait_for_element_to_disappear(
+            lambda x: tester.driver.find_element_by_xpath(
                 "//div[@class='card-header bg-primary d-flex']/div"
-                "[contains(text(), 'Maintenance')]"):
-            tester._screenshot()
-            screen_shot_taken = True
-            tester.driver.find_element_by_css_selector(
-                ".btn.btn-sm-sq.btn-primary.pg-bg-close > i").click()
+                "[contains(text(), 'Maintenance')]"))
     except Exception:
-        pass
-
-    if not screen_shot_taken:
-        tester._screenshot()
+        tester.driver.find_element_by_css_selector(
+            ".btn.btn-sm-sq.btn-primary.pg-bg-close > i").click()
diff --git a/web/regression/python_test_utils/test_utils.py b/web/regression/python_test_utils/test_utils.py
index 54be70a98..2e8a0eb8c 100644
--- a/web/regression/python_test_utils/test_utils.py
+++ b/web/regression/python_test_utils/test_utils.py
@@ -194,6 +194,35 @@ def create_table(server, db_name, table_name, extra_columns=[]):
         traceback.print_exc(file=sys.stderr)
 
 
+def delete_table(server, db_name, table_name):
+    """
+    This function delete the table in given database
+    :param server: server details
+    :type server: dict
+    :param db_name: database name
+    :type db_name: str
+    :param table_name: table name
+    :type table_name: str
+    :return: None
+    """
+    try:
+        connection = get_db_connection(
+            db_name,
+            server['username'],
+            server['db_password'],
+            server['host'],
+            server['port'],
+            server['sslmode']
+        )
+        pg_cursor = connection.cursor()
+        pg_cursor.execute(
+            '''DROP TABLE IF EXISTS "%s"''' % table_name)
+        connection.commit()
+
+    except Exception:
+        traceback.print_exc(file=sys.stderr)
+
+
 def create_table_with_query(server, db_name, query):
     """
     This function create the table in given database name
@@ -774,22 +803,28 @@ def configure_preferences(default_binary_path=None):
 
 
 def reset_layout_db(user_id=None):
-    conn = sqlite3.connect(config.TEST_SQLITE_PATH)
-    cur = conn.cursor()
+    retry = 3
+    while retry > 0:
+        try:
+            conn = sqlite3.connect(config.TEST_SQLITE_PATH)
+            cur = conn.cursor()
 
-    if user_id is None:
-        cur.execute(
-            'DELETE FROM SETTING WHERE SETTING in '
-            '("Browser/Layout", "SQLEditor/Layout", "Debugger/Layout")'
-        )
-    else:
-        cur.execute(
-            'DELETE FROM SETTING WHERE SETTING in '
-            '("Browser/Layout", "SQLEditor/Layout", "Debugger/Layout")'
-            ' AND USER_ID=?', user_id
-        )
-    conn.commit()
-    conn.close()
+            if user_id is None:
+                cur.execute(
+                    'DELETE FROM SETTING WHERE SETTING in '
+                    '("Browser/Layout", "SQLEditor/Layout", "Debugger/Layout")'
+                )
+            else:
+                cur.execute(
+                    'DELETE FROM SETTING WHERE SETTING in '
+                    '("Browser/Layout", "SQLEditor/Layout", "Debugger/Layout")'
+                    ' AND USER_ID=?', user_id
+                )
+            conn.commit()
+            conn.close()
+            break
+        except Exception:
+            retry -= 1
 
 
 def remove_db_file():
